/*
 *	The purpose of this file is to stress apache/mod_mono/xsp/talweg
 *	to test performances/settings/codes.
 *	so when you stress this programm don't forget you stress required servers too !
 *	so take care to choose urls that are on differents servers.
 */

using System;
using System.Net;
using System.IO;
using System.Collections;
using System.Threading;
using System.Security.Cryptography.X509Certificates;


namespace talweg.BenchMarks {
	class test {
		static void Main(string[] args) {
			if(args.Length != 2){
				Console.WriteLine("usage talwegbench numthread urlfilename");
				return;
			}
			// Trust all certificates  [TODO] : Not All !
			System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatesPolicy();

			Bench b = new Bench(Int32.Parse(args[0]),args[1]);
			
			DateTime begin = DateTime.Now;
			Thread thread = null;
			ThreadStart threadStart = new ThreadStart(b.Begin);
			thread = new Thread(threadStart);
			thread.IsBackground = true;
			thread.Start();
			while (thread.IsAlive) {
				Thread.Sleep(100);
			}
		  TimeSpan diff = DateTime.Now - begin;
		  Console.WriteLine(diff.ToString().Substring(0,8));
		  b.PrintResult();
		}
	}
	class Bench {
		string currenturl = String.Empty;
		int numthread;
		string filename;
		ArrayList benchitems = new ArrayList();
		
		public Bench (int numthread,string filename) {
			this.numthread = numthread;
			this.filename = filename;
		}
		public void Begin() {
			ArrayList threads = new ArrayList();
			using (StreamReader sr = new StreamReader(filename)) {
				int x = 0;
		        while ((currenturl = sr.ReadLine()) != null && (x++ < numthread)) {
					// Do request thread
					Thread thread = null;
			      	ThreadStart threadStart = new ThreadStart(DoRequest);
	    			  thread = new Thread(threadStart);
					threads.Add(thread);
			      	thread.IsBackground = false;
    			  	thread.Start();
					if(sr.Peek() == -1)
						sr.BaseStream.Position = 0;
        		}
			}
/*			foreach(Thread t in threads) {
				t.Start();
			}*/
			foreach(Thread t in threads) {
				while(t.IsAlive)Thread.Sleep(100);
			}
		}
		public void DoRequest() {
			BenchItem i = new BenchItem(currenturl);				
			HttpWebRequest myWebRequest = (HttpWebRequest)WebRequest.Create(currenturl);
			HttpWebResponse myWebResponse = (HttpWebResponse)myWebRequest.GetResponse(); 
			//Console.WriteLine(myWebResponse.StatusCode.ToString());
			i.End(myWebResponse.StatusCode.ToString());
			benchitems.Add(i);
			myWebResponse.Close();
		}
		public void PrintResult() {
			int x = 1;
			foreach(BenchItem i in benchitems) {
				Console.WriteLine((x++).ToString() + " -- " + i.StatusCode + " -- " + i.Duration.ToString() + " -- " +i.Url);
			}

		}
	}
	class BenchItem {
		DateTime begin;
		DateTime end;
		string url;
		string statuscode;
		
		public BenchItem(string url){
			this.url = url;
			this.begin = DateTime.Now;
		}
		public void End(string statuscode) {
			this.statuscode = statuscode;
			this.end = DateTime.Now;
		}
		public TimeSpan Duration {
			get { return (end - begin); }
		}	
		public string Url {
			get { return url; }
		}	
		public string StatusCode {
			get { return statuscode;}
		}	

	}
  public class TrustAllCertificatesPolicy : System.Net.ICertificatePolicy {
				    public bool CheckValidationResult(ServicePoint sp, X509Certificate cert,WebRequest req, int problem){
									      return true;
											    }
					  }

}
