/*
 * 401 module, is to prevent redirect on 401 HttpResponse code.
 * Copyright (C) 2006 COLIN Cyrille.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */

using System.Security.Permissions;
using System.Security.Principal;
using System.Text;
using System.Web.Configuration;
using System.Web.Util;

namespace System.Web.Security {
				
	public class Code401Module : IHttpModule	{
					
		public Code401Module () 	{	}

		public void Dispose () 	{	}

		public void Init (HttpApplication app) 	{
				app.EndRequest += new EventHandler (OnEndRequest);
		}

		void OnEndRequest (object sender, EventArgs args)	{
			HttpApplication app = (HttpApplication) sender;
			HttpContext context = app.Context;
			if (context.Response.StatusCode != 901) 	return;
			context.Response.StatusCode = 401;
		}
	
	}

}

