using System;
using System.Xml;
using System.Configuration;
using talweg.talwegextended;

namespace talweg.Config {
	public class talwegextendedConfigurationSectionHandler:IConfigurationSectionHandler {
		private static readonly log4net.ILog log = log4net.LogManager.GetLogger("talweg");					
    public talwegextendedConfigurationSectionHandler(){}
		
    public object Create(object parent,object configContext, System.Xml.XmlNode section) {
				NetworkServices ns = new NetworkServices();
				XmlNodeList nodelist = section.SelectNodes("networkServices/networkService");
				string server,label;
				int port;
				bool enable;
				foreach(XmlNode n in nodelist) {
					if(n.SelectSingleNode("label") == null) {
						log.Error("talwegextended configuration : Property label is required.");
						continue;
					}
					if(n.SelectSingleNode("port") == null) {
						log.Error("talwegextended configuration : Property port is required.");
						continue;
					}
					NetworkService networkService = new NetworkService();
					networkService.Label = n.SelectSingleNode("label").InnerText;
					try {
						networkService.Port = Int32.Parse(n.SelectSingleNode("port").InnerText);
					} catch {
						log.Error("talwegextended configuration : Property port is malformed");
						continue;
					}
					if(n.SelectSingleNode("server") != null ) {
							networkService.Server = n.SelectSingleNode("server").InnerText;
							log.Info("server : " + networkService.Server);
					}
					if(n.Attributes["enable"] != null) {
							try {
									networkService.IsEnable = Boolean.Parse(n.Attributes["enable"].InnerText);
							} catch {
									log.Error("talwegextended configuration : Property port is malformed");		
									continue;
							}
					}
					ns.Add(networkService);	
				}
				return ns;
    }
	}
}
