using System;
using System.Text;
using System.Text.RegularExpressions;

namespace talweg.Utils {
	public class Url {
		public static string GetUrl(string url,string suffix,bool prefix) {
			url = url.Replace("--",".");
			Match m_all = Regex.Match(url,@"(^http[s]?://)([^/]+)(.*)");
			if(m_all.Groups.Count > 1) {
				string host = m_all.Groups[2].ToString();
				if(suffix != "") {
					suffix = suffix.StartsWith(".")?suffix:"."+suffix;
					host = host.Replace(suffix,"");
				}
				Match m = Regex.Match(host,@"^(s\.|u\.)(.*?)[-]?([\d]*)$");
				if(m.Groups.Count > 1) {
					string result = String.Empty;
					if(prefix)result = (m.Groups[1].ToString() == "s.") ? "https://":"http://";
					result += m.Groups[2].ToString();
					if(result.EndsWith(".")){ // it's a IP
						result += m.Groups[3].ToString();	
					} else {
						result += (m.Groups[3].ToString() == "") ? "":":"+m.Groups[3].ToString();
					}
					result += m_all.Groups[3].ToString();
					return result;
				}
			}
			return String.Empty;
		}
		public static string GetHost(string host,string suffix) {
				string result = String.Empty;
			  host = host.Replace("--",".");
				if(suffix != "") {
	       suffix = suffix.StartsWith(".")?suffix:"."+suffix;
		     host = host.Replace(suffix,"");
        }
				Match m = Regex.Match(host,@"^(s\.|u\.)(.*?)[-]?([\d]*)$");
        if(m.Groups.Count > 1) {
          result = String.Empty;
          result += m.Groups[2].ToString();
          if(result.EndsWith(".")){ // it's a IP
            result += m.Groups[3].ToString();
          } else {
            result += (m.Groups[3].ToString() == "") ? "":":"+m.Groups[3].ToString();
          }
				}
        return result;
		}
		public static string HostEncode(string host,string suffix,string prefix) {
			suffix = suffix.StartsWith(".")?suffix:"."+suffix;
			return prefix + host.Replace(".","--")+suffix;
		}
		public static string ParseUrl(string url,string suffix) {
			if(url.IndexOf(suffix) != -1) return url;
			string url2 = url.Replace(@"\/","/");
			bool isescaped = false;
			if(String.Compare(url,url2) != 0 ) isescaped = true;
			url = url2;
			Match m = Regex.Match(url,@"(^http[s]?://)([^/]+)(.*)");
			if(m.Groups.Count > 1) {
				string result = String.Empty;
				result += "https://";
				result += (m.Groups[1].ToString() == "https://") ? "s--":"u--";
				result += m.Groups[2].ToString().Replace(":","-").Replace(".","--");
				result += suffix.StartsWith(".")?suffix:"."+suffix;
				result += m.Groups[3].ToString();
				if(isescaped) result = result.Replace("/",@"\/");
				return result;
			}else {
				return String.Empty;
			}
		}
		//
		//	
		//
		public static string CleanUrl(string url,string suffix) {
				if(suffix == String.Empty || url == String.Empty) return url;
				string encodedSuffix = suffix.Replace("-","%2d").Replace(".","%2e");
				int curPos = 0;

				if(	url.IndexOf(suffix) == -1 &&
						url.IndexOf(encodedSuffix) == -1 ) 
										return url;
				if(!suffix.StartsWith("."))suffix = "."+suffix;
				if(!encodedSuffix.StartsWith("%2e")) encodedSuffix = "%2e"+ encodedSuffix;
				
				url = url.Replace(suffix,"");
				url = url.Replace("https://s--","https://");
				url = url.Replace("https://u--","http://");
				url = url.Replace(encodedSuffix,"");
				url = url.Replace("https%3a%2f%2fs%2d%2d","https%3a%2f%2f");
				url = url.Replace("https%3a%2f%2fu%2d%2d","http%3a%2f%2f");
				url = url.Replace("--",".");
				url = url.Replace("%2d%2d","%2e");
				return url;
		}
	}
}
